"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var TableHead_1 = require("./TableHead");
var TableBody_1 = require("./TableBody");
var use_middleware_1 = require("./util/use-middleware");
var create_rocket_1 = require("../_util/create-rocket");
var addons = tslib_1.__importStar(require("./addons"));
var with_statics_1 = require("../_util/with-statics");
exports.Table = with_statics_1.withStatics(function Table(props) {
    var _a = props.addons, addons = _a === void 0 ? [] : _a, bordered = props.bordered, compact = props.compact;
    var headRef = react_1.useRef(null);
    var bodyRef = react_1.useRef(null);
    // 同步 body 和 header 滚动位置
    function handleScroll() {
        if (headRef.current && bodyRef.current) {
            headRef.current.scrollLeft = bodyRef.current.scrollLeft;
        }
    }
    // 执行 addon props middleware
    // eslint-disable-next-line no-param-reassign
    props = use_middleware_1.useMiddleware(addons, "onInjectProps")(props);
    var renderTable = use_middleware_1.useMiddleware(addons, "onInjectTable")(function (props) { return (react_1.default.createElement("div", { className: classnames_1.default("tea-table", {
            "tea-table--compact": compact,
            "tea-table--bordered": bordered,
        }) },
        react_1.default.createElement(TableHead_1.TableHead, tslib_1.__assign({ ref: headRef }, props)),
        react_1.default.createElement(TableBody_1.TableBody, tslib_1.__assign({ ref: bodyRef, onScrollCapture: handleScroll }, props)))); });
    return renderTable(props);
}, {
    addons: addons,
    ActionPanel: create_rocket_1.createRocket("ActionPanel", "div.tea-table__action-panel"),
});
//# sourceMappingURL=Table.js.map