import { TableAddon } from "../TableProps";
import { CheckTreeRelation } from "../../checktree";
/**
 * `indentable` 插件用于支持表格缩进样式。
```jsx
import { indentable } from '@tea/component/table/addons/indentable';
function Example() {
  return <Table addons={[indentable(options)]} />;
}
```
 */
export interface IndentableOptions {
    /**
     * 子级相对父级缩进量
     * @default 20
     */
    indent?: number;
    /**
     * 行的层级关系
     */
    relations?: CheckTreeRelation;
    /**
     * 提供一个列的 `key`，将选择组件插入到一个目标列
     */
    targetColumnKey: string;
}
export declare function indentable(options: IndentableOptions): TableAddon;
