import React from "react";
import { TableAddon } from "../TableProps";
/**
 * `removeable` 插件用于支持表格可删除行的样式及操作。
```jsx
import { removeable } from '@tea/component/table/addons/removeable';
function Example() {
  return <Table addons={[removeable(options)]} />;
}
```
 */
export interface RemoveableOptions<Record = any> {
    /**
     * 删除操作回调
     */
    onRemove?: (rowKey: string, context: {
        event: React.SyntheticEvent;
        record: Record;
    }) => void;
    /**
     * 列宽度，可以指定 CSS 属性或数字 (单位：px)
     * @default 46
     */
    width?: string | number;
}
export declare function removeable({ onRemove, width, }: RemoveableOptions): TableAddon;
