import React from "react";
import { Layout } from "@tea/component/layout";
import { Card } from "@tea/component/card";
import { Affix } from "@tea/component/affix";
import { Button } from "@tea/component/button";

const { Body, Content } = Layout;

function LayoutContentExample() {
  return (
    <Layout>
      <Body>
        <Content className="affix-target">
          <Content.Header title="内容标题" />
          <Content.Body>
            {/* 内容区域一般使用 Card 组件显示内容 */}
            <Card style={{ height: 1200 }}>
              <Card.Body>
                <Affix
                  offsetTop={20}
                  target={() => document.querySelector(".affix-target")}
                >
                  <Button>钉在顶部</Button>
                </Affix>
              </Card.Body>
            </Card>
            <Affix
              offsetBottom={0}
              target={() => document.querySelector(".affix-target")}
            >
              <Card>
                <Card.Body>
                  <Button type="primary">钉在底部</Button>
                </Card.Body>
              </Card>
            </Affix>
          </Content.Body>
          <Content.Footer>
            <div className="layout-footer-demo">
              (可选项)自定义页脚
              <br />
              京公网安备 11010802017518 粤B2-20090059-1
            </div>
          </Content.Footer>
        </Content>
      </Body>
    </Layout>
  );
}

export default function Demo() {
  return (
    <section
      style={{
        height: 360,
        border: "1px solid #ddd",
      }}
    >
      <LayoutContentExample />
    </section>
  );
}
