/* eslint-disable no-undef */
import React, { Component } from "react";
import { mount } from "enzyme";
import renderer from "react-test-renderer";
import { Card } from "../Card";

describe("Card", () => {
  const card = (
    <Card>
      <Card.Header>
        <h3>卡片头部</h3>
      </Card.Header>
      <Card.Body title="内容区标题" subtitle="(小标题)">
        内容区
      </Card.Body>
      <Card.Footer>卡片底部</Card.Footer>
    </Card>
  );

  const cardWithBorder = (
    <Card bordered>
      <Card.Header>
        <h3>卡片头部</h3>
      </Card.Header>
      <Card.Body title="内容区标题" subtitle="(小标题)">
        内容区
      </Card.Body>
      <Card.Footer>卡片底部</Card.Footer>
    </Card>
  );

  test("render correctly", () => {
    // create card
    let component = renderer.create(card);
    let tree = component.toJSON();
    expect(tree).toMatchSnapshot();

    // card with border
    component = renderer.create(cardWithBorder);
    tree = component.toJSON();
    expect(component).toMatchSnapshot();
  });
});
