/* eslint-disable no-undef */
import React from "react";
import { mount } from "enzyme";
import { Overlay } from "../Overlay";

describe("Overlay", () => {
  beforeAll(() => {
    jest.useFakeTimers();
  });

  afterAll(() => {
    jest.useRealTimers();
  });

  it("render correctly", () => {
    const close = jest.fn();
    const open = jest.fn();
    const wrapper = mount(
      <Overlay
        layers={[
          <Overlay.Layer
            key="layer"
            visible
            content={
              <div>
                我是浮层内容，<a onClick={close}>关闭</a>
              </div>
            }
          />,
        ]}
      >
        {ref => (
          <a ref={ref} onClick={open}>
            点击弹出浮层
          </a>
        )}
      </Overlay>
    );
    expect(wrapper.render()).toMatchSnapshot();
  });
});
