import React, { useState } from "react";
import {
  RegionSelect,
  RegionPanel,
  RegionOption,
} from "@tea/component/regionselect";

export default function RegionSelectExample() {
  const [region, setRegion] = useState("gz");

  const { Head, Column, Group } = RegionPanel;

  return (
    <RegionSelect
      value={region}
      onChange={value => setRegion(value)}
      moreInfo={region === "all" ? null : "其它地域云主机 (120)"}
    >
      <RegionPanel>
        <Head>
          <RegionOption value="all" flag="Globe">
            全部地域 (1108)
          </RegionOption>
        </Head>
        <Column>
          <Group name="中国大陆">
            <RegionOption value="gz" flag="China">
              广州 (20)
            </RegionOption>
            <RegionOption value="sh" flag="China" dot>
              上海 (20)
            </RegionOption>
          </Group>
          <Group name="游戏专区">
            <RegionOption value="bj" flag="China">
              北京 (20)
            </RegionOption>
          </Group>
        </Column>
        <Column>
          <Group name="亚洲">
            <RegionOption value="hk" flag="Hongkong">
              香港 (20)
            </RegionOption>
            <RegionOption value="ia" flag="India">
              印度 (20)
            </RegionOption>
            <RegionOption value="ko" flag="Korea">
              韩国 (20)
            </RegionOption>
            <RegionOption value="ta" flag="Thailand">
              泰国 (20)
            </RegionOption>
            <RegionOption value="sg" flag="Singapore">
              新加坡 (20)
            </RegionOption>
            <RegionOption value="jp" flag="Japan">
              日本 (20)
            </RegionOption>
          </Group>
        </Column>
        <Column>
          <Group name="北美洲">
            <RegionOption value="gg" flag="America">
              硅谷 (20)
            </RegionOption>
            <RegionOption value="dld" flag="Canada">
              多伦多 (20)
            </RegionOption>
          </Group>
        </Column>
        <Column>
          <Group name="欧洲">
            <RegionOption value="fl" flag="Germany">
              法兰克福 (20)
            </RegionOption>
            <RegionOption value="mo" flag="Russia">
              莫斯科 (20)
            </RegionOption>
          </Group>
        </Column>
      </RegionPanel>
    </RegionSelect>
  );
}
