import React from "react";
import classNames from "classnames";
import { FilterButtonProps } from "./FilterableTypes";
import { SelectMultiple } from "../../../select";

export function MultipleFilterButton({
  all,
  className,
  style,
  children,
  options,
  value,
  onChange,
  shouldOptionExcludeFromAll,
}: FilterButtonProps<string[]>) {
  const active = Boolean(value && value.length > 0);
  return (
    <span
      className={classNames(
        "tea-table__filterbtn",
        { "is-active": active },
        className
      )}
      style={style}
    >
      <SelectMultiple
        appearence="filter"
        button={children}
        style={style}
        options={options.map(option => ({
          ...option,
          text: option.text || option.label,
        }))}
        allOption={all ? { ...all, text: all.text || all.label } : false}
        value={value}
        onChange={onChange}
        shouldOptionExcludeFromAll={shouldOptionExcludeFromAll}
      />
    </span>
  );
}
