import React, { forwardRef } from "react";
import classNames from "classnames";
import { Icon } from "../icon";

export interface TabItemProps {
  label: React.ReactNode;
  actived: boolean;
  disabled: boolean;
  onClose: (evt: React.MouseEvent) => void;
  onClick: (evt: React.MouseEvent) => void;
}

export const TabItem = forwardRef(
  (
    { label, onClick, actived, disabled, onClose }: TabItemProps,
    ref: React.Ref<HTMLLIElement>
  ) => (
    <li className="tea-tabs__tabitem" ref={ref}>
      <a
        className={classNames("tea-tabs__tab", {
          "is-active": actived,
          "is-disabled": disabled,
        })}
        onClick={disabled ? null : onClick}
      >
        {label}
      </a>
      {onClose && (
        <a className="tea-tabs__remove" onClick={onClose}>
          <Icon type="dismiss" />
        </a>
      )}
    </li>
  )
);
