import React from "react";
import classNames from "classnames";
import { StyledProps } from "../_type";

export interface TabPanelProps extends StyledProps {
  /**
   * 选项卡 ID
   */
  id: string;

  /**
   * 选项卡内容
   */
  children?: React.ReactNode;
}

/**
 * TabPanel 应该用在 Tabs 内部，如果单独使用，会直接渲染其 children
 */
export function TabPanel({ children, className, style = {} }: TabPanelProps) {
  return (
    <div
      className={classNames("tea-tabs__tabpanel", className)}
      style={{ ...style, flexShrink: 0 }}
    >
      {children}
    </div>
  );
}
