import React from "react";
import classNames from "classnames";
import { useTranslation } from "../i18n";
import { StyledProps } from "../_type";

export interface EmptyTipProps extends StyledProps {
  /**
   * 空数据提示文案
   * @default "暂无数据"
   */
  emptyText?: React.ReactNode;
}

export function EmptyTip({ emptyText, className, style }: EmptyTipProps) {
  const t = useTranslation();
  const text = emptyText || t.emptyText;
  return (
    <span className={classNames("tea-action-state", className)} style={style}>
      {typeof text === "string" ? (
        <span className="tea-action-state__text">{text}</span>
      ) : (
        text
      )}
    </span>
  );
}
