import { Color } from "../../type";
import { Context } from "../context";
export declare abstract class Shape {
    ctx: Context;
    constructor(ctx: Context);
    /**
     * 设置数据映射
     * @param pos 同 chart.position
     */
    abstract position(pos: string): this;
    /**
     * 以颜色来作为数据映射
     * @param color 字段名
     */
    abstract color(color: string | Color): this;
    /**
     * 设置尺寸
     * @param size 值
     */
    abstract size(size: number): this;
    /**
     * 开始绘图
     */
    abstract draw(): this;
}
