"use strict";
/**
 * @fileOverview
 *
 * 有序维护选区
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 保证 selection 保持与 records 有相同的偏序关系，查找插入位置
 */
function findInsertPosition(records, selection, item) {
    var recordIndex = records.indexOf(item);
    var ri = 0;
    var si = 0;
    while (records[ri] && selection[si]) {
        if (ri === recordIndex)
            break;
        if (records[ri] === selection[si] || records[ri].id === selection[si].id) {
            si += 1;
        }
        ri += 1;
    }
    return si;
}
/**
 * 插入到选区中，保持与 records 相同的偏序顺序
 */
function selectionInsert(records, selection, item) {
    var newSelection = selection ? selection.slice() : [];
    var index = newSelection.indexOf(item);
    if (index === -1) {
        var insertIndex = findInsertPosition(records, newSelection, item);
        newSelection.splice(insertIndex, 0, item);
    }
    return newSelection;
}
exports.selectionInsert = selectionInsert;
/**
 * 从选取中删除
 */
function selectionRemove(records, selection, item) {
    var newSelection = selection.slice();
    var index = newSelection.indexOf(item);
    if (index > -1) {
        newSelection.splice(index, 1);
    }
    return newSelection;
}
exports.selectionRemove = selectionRemove;
//# sourceMappingURL=selection.js.map