"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var noop = function () { };
function useDefault(value, defaultValue, onChange) {
    // 无论是否受控，都要 useState，因为 Hooks 是无条件的
    var _a = tslib_1.__read(react_1.useState(defaultValue), 2), internalValue = _a[0], setInternalValue = _a[1];
    // 受控模式
    if (typeof value !== "undefined") {
        return [value, onChange || noop];
    }
    // 非受控模式
    return [
        internalValue,
        function (newValue) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            setInternalValue(newValue);
            if (typeof onChange === "function") {
                onChange.apply(void 0, tslib_1.__spread([newValue], args));
            }
        },
    ];
}
exports.useDefault = useDefault;
//# sourceMappingURL=use-default.js.map