"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useScheduleUpdate(deps) {
    if (deps === void 0) { deps = []; }
    var scheduleRef = react_1.useRef(null);
    react_1.useEffect(function () {
        if (scheduleRef.current) {
            scheduleRef.current();
        }
    }, deps);
    return function (fn) {
        scheduleRef.current = fn;
    };
}
exports.useScheduleUpdate = useScheduleUpdate;
//# sourceMappingURL=use-schedule-update.js.map