"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
exports.withResize = function (methodName) { return function (Component) {
    var _a;
    return _a = /** @class */ (function (_super) {
            tslib_1.__extends(WithResize, _super);
            function WithResize() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.resizeListener = function (evt) {
                    if (_this.instance) {
                        _this.instance[methodName](evt);
                    }
                };
                return _this;
            }
            WithResize.prototype.componentDidMount = function () {
                window.addEventListener("resize", this.resizeListener);
            };
            WithResize.prototype.componentWillUnmount = function () {
                window.removeEventListener("resize", this.resizeListener);
            };
            WithResize.prototype.render = function () {
                var _this = this;
                return react_1.default.createElement(Component, tslib_1.__assign({}, this.props, { ref: function (instance) {
                        _this.instance = instance;
                        return instance;
                    } }));
            };
            return WithResize;
        }(react_1.default.Component)),
        _a.displayName = "withResize(" + (Component.displayName ||
            Component.name ||
            "Unknown") + ")",
        _a;
}; };
//# sourceMappingURL=with-resize.js.map