"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var use_default_1 = require("../_util/use-default");
var icon_1 = require("../icon");
var transition_1 = require("../transition");
function Alert(props) {
    var _a;
    var type = props.type, children = props.children, className = props.className, style = props.style, onClose = props.onClose;
    var alertClassName = classnames_1.default("tea-alert", (_a = {},
        _a["tea-alert--" + type] = type,
        _a), className);
    var _b = tslib_1.__read(use_default_1.useDefault(props.visible, props.defaultVisible, function (visible) { return !visible && onClose && onClose(); }), 2), visible = _b[0], onVisibleChange = _b[1];
    var isClosable = typeof visible === "boolean";
    var alertElement = (react_1.default.createElement("div", { className: alertClassName, style: style },
        react_1.default.createElement("div", { className: "tea-alert__info" }, children),
        isClosable && (react_1.default.createElement(icon_1.Icon, { link: true, type: "close", "aria-label": "close", onClick: function () { return onVisibleChange(false); } }))));
    if (isClosable) {
        return react_1.default.createElement(transition_1.FadeTransition, { in: visible }, alertElement);
    }
    return alertElement;
}
exports.Alert = Alert;
//# sourceMappingURL=Alert.js.map