"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var BlankSteps_1 = require("./BlankSteps");
var mediaobject_1 = require("../mediaobject");
var with_statics_1 = require("../_util/with-statics");
exports.Blank = with_statics_1.withStatics(function Blank(_a) {
    var theme = _a.theme, description = _a.description, operation = _a.operation, extra = _a.extra, children = _a.children, className = _a.className, style = _a.style;
    var image = getCustomTheme(theme).image;
    return (react_1.default.createElement("div", { className: classnames_1.default("tea-blank-page", {
            "default-error": theme === "error",
            "default-open": theme === "open",
            "default-arrears": theme === "arrears",
            "default-permission": theme === "permission",
        }, className), style: style },
        react_1.default.createElement(mediaobject_1.MediaObject, { align: "middle", media: react_1.default.createElement("div", { className: "tea-blank-page__media" },
                react_1.default.createElement("span", { className: "tea-blank-page__media-bg" }, image.background && react_1.default.createElement("img", { src: image.background, alt: "" })),
                react_1.default.createElement("span", { className: "tea-blank-page__media-gif" }, image.gif && react_1.default.createElement("img", { src: image.gif, alt: "" }))) },
            react_1.default.createElement("h4", { className: "tea-h4 tea-mb-2n" }, description),
            children,
            (operation || extra) && (react_1.default.createElement("div", { className: "tea-blank-page__op" },
                operation,
                extra && react_1.default.createElement("div", { className: "tea-mt-4n" }, extra))))));
}, {
    Steps: BlankSteps_1.BlankSteps,
});
function getCustomTheme(theme) {
    if (typeof theme === "string") {
        return { image: { background: null, gif: null } };
    }
    return tslib_1.__assign({ image: {} }, theme);
}
//# sourceMappingURL=Blank.js.map