"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var is_child_of_type_1 = require("../_util/is-child-of-type");
var with_statics_1 = require("../_util/with-statics");
exports.Breadcrumb = with_statics_1.withStatics(function Breadcrumb(_a) {
    var large = _a.large, children = _a.children, className = _a.className, style = _a.style;
    return (react_1.default.createElement("ol", { className: classnames_1.default("tea-breadcrumb", className, {
            "tea-breadcrumb--fz-large": large,
        }), style: style }, react_1.default.Children.map(children, function (child, index) {
        if (is_child_of_type_1.isChildOfType(child, BreadcrumbItem) &&
            index === react_1.default.Children.count(children) - 1) {
            return react_1.default.cloneElement(child, {
                current: true,
            });
        }
        return child;
    })));
}, {
    Item: BreadcrumbItem,
});
function BreadcrumbItem(_a) {
    var current = _a.current, children = _a.children, className = _a.className, style = _a.style;
    if (typeof children === "string") {
        // eslint-disable-next-line no-param-reassign
        children = react_1.default.createElement("span", null, children);
    }
    return (react_1.default.createElement("li", { className: classnames_1.default("tea-breadcrumb__item", className), style: style }, react_1.default.isValidElement(children)
        ? react_1.default.cloneElement(children, {
            className: classnames_1.default(children.props.className, "tea-breadcrumb__item-title", {
                "is-current": current,
            }),
        })
        : children));
}
exports.BreadcrumbItem = BreadcrumbItem;
//# sourceMappingURL=Breadcrumb.js.map