/// <reference types="react" />
import { Moment } from "moment";
import { CellStatus } from "./BaseTable";
import { RangeDateType, CalendarTableType, DateChangeContext } from "../DateProps";
export interface DateTableProps {
    /**
     * 当前展示日期
     */
    current: Moment;
    /**
     * 当前选中的日期
     */
    value: Moment;
    /**
     * 允许选择的时间范围限制
     */
    range?: RangeDateType;
    /**
     * 可选的日期范围
     */
    disabledDate?: (date: Moment) => boolean;
    /**
     * Cell 渲染状态
     */
    cellStatus?: (date: Moment) => CellStatus;
    /**
     * 选中回调
     */
    onSelect?: (value: Moment, context: DateChangeContext) => void;
    /**
     * type 变更回调
     */
    onTypeChange?: (type: CalendarTableType) => void;
    /**
     * 当前展示日期变更回调
     */
    onCurrentChange?: (current: Moment) => void;
}
export declare function DateTable({ value, current, onCurrentChange, range, disabledDate, onSelect, onTypeChange, cellStatus, }: DateTableProps): JSX.Element;
