/// <reference types="react" />
import { Moment } from "moment";
import { CellStatus } from "./BaseTable";
import { RangeDateType, CalendarTableType, DateChangeContext } from "../DateProps";
export interface MonthTableProps {
    /**
     * 当前展示时间
     */
    current: Moment;
    /**
     * 允许选择的时间范围限制
     */
    range?: RangeDateType;
    cellStatus?: (date: Moment) => CellStatus;
    onSelect?: (value: Moment, context: DateChangeContext) => void;
    onTypeChange?: (type: CalendarTableType) => void;
    onCurrentChange?: (current: Moment) => void;
    hideCaption?: boolean;
}
export declare function MonthTable({ current, onCurrentChange, range, onSelect, onTypeChange, cellStatus, hideCaption, }: MonthTableProps): JSX.Element;
