"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var create_rocket_1 = require("../_util/create-rocket");
var forward_ref_with_statics_1 = require("../_util/forward-ref-with-statics");
var justify_1 = require("../justify");
var CardHeader = create_rocket_1.createRocket("CardHeader", "div.tea-card__header");
var CardFooter = create_rocket_1.createRocket("CardFooter", "div.tea-card__footer");
var CardBody = react_1.forwardRef(function (props, ref) {
    var className = props.className, style = props.style, title = props.title, subtitle = props.subtitle, operation = props.operation, children = props.children;
    return (react_1.default.createElement("div", { ref: ref, className: classnames_1.default("tea-card__body", className), style: style },
        (title || subtitle || operation) && (react_1.default.createElement("div", { className: "tea-card__title" },
            react_1.default.createElement(justify_1.Justify, { left: react_1.default.createElement("h3", { className: "tea-h3" },
                    title,
                    subtitle && (react_1.default.createElement("span", { className: "tea-card__subtitle" }, subtitle))), right: operation }))),
        react_1.default.createElement("div", { className: "tea-card__content" }, children)));
});
exports.Card = forward_ref_with_statics_1.forwardRefWithStatics(function (props, ref) {
    var className = props.className, style = props.style, children = props.children, bordered = props.bordered, full = props.full;
    var cardClassName = classnames_1.default("tea-card", {
        "tea-card--bordered": bordered,
        "tea-card--full": full === true,
        "tea-card--full-with-header": full === "withHeader",
    }, className);
    return (react_1.default.createElement("div", { ref: ref, className: cardClassName, style: style }, children));
}, 
// Card statics
{
    Header: CardHeader,
    Body: CardBody,
    Footer: CardFooter,
});
exports.Card.displayName = "Card";
//# sourceMappingURL=Card.js.map