"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var CollapseContext_1 = require("./CollapseContext");
var icon_1 = require("../icon");
function CollapsePanel(_a) {
    var id = _a.id, title = _a.title, content = _a.content, className = _a.className, style = _a.style;
    var _b = react_1.useContext(CollapseContext_1.CollapseContext), activeIds = _b.activeIds, onActive = _b.onActive;
    var active = activeIds.includes(id);
    function handleClick(event) {
        var context = { event: event };
        if (active) {
            onActive(activeIds.filter(function (activeId) { return activeId !== id; }), context);
        }
        else {
            onActive(tslib_1.__spread(activeIds, [id]), context);
        }
    }
    return (react_1.default.createElement("div", { className: classnames_1.default("tea-accordion", className, {
            "is-active": active,
        }), style: style },
        react_1.default.createElement("div", { className: "tea-accordion__header" },
            react_1.default.createElement(icon_1.Icon, { type: active ? "arrowup" : "arrowdown" }),
            react_1.default.createElement("span", { className: "tea-accordion__header-title", onClick: handleClick }, title)),
        react_1.default.createElement("div", { className: "tea-accordion__body" }, content)));
}
exports.CollapsePanel = CollapsePanel;
//# sourceMappingURL=CollapsePanel.js.map