"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var moment_1 = tslib_1.__importStar(require("moment"));
var CalendarPart_1 = tslib_1.__importDefault(require("../calendar/CalendarPart"));
var controlled_1 = require("../form/controlled");
var CalendarTable_1 = require("../calendar/CalendarTable");
var Input_1 = require("../input/Input");
var dropdown_1 = require("../dropdown");
var i18n_1 = require("../i18n");
var with_statics_1 = require("../_util/with-statics");
var Popover_1 = require("../popover/Popover");
var util_1 = require("./util");
var use_default_1 = require("../_util/use-default");
exports.MonthPicker = with_statics_1.withStatics(function MonthPicker(props) {
    var t = i18n_1.useTranslation(moment_1.default);
    var _a = controlled_1.useDefaultValue(props), header = _a.header, className = _a.className, style = _a.style, value = _a.value, onChange = _a.onChange, disabled = _a.disabled, _b = _a.format, format = _b === void 0 ? "YYYY-MM" : _b, _c = _a.placeholder, placeholder = _c === void 0 ? t.selectDate : _c, _d = _a.defaultOpen, defaultOpen = _d === void 0 ? false : _d, open = _a.open, _e = _a.onOpenChange, onOpenChange = _e === void 0 ? function () { return null; } : _e, _f = _a.placement, placement = _f === void 0 ? "bottom-start" : _f, _g = _a.placementOffset, placementOffset = _g === void 0 ? 5 : _g, _h = _a.closeOnScroll, closeOnScroll = _h === void 0 ? true : _h;
    // 当前面板类型
    var _j = tslib_1.__read(react_1.useState("month"), 2), type = _j[0], setType = _j[1];
    // 当前面板展示时间
    var _k = tslib_1.__read(react_1.useState(moment_1.isMoment(value) ? value : moment_1.default()), 2), curViewMoment = _k[0], setCurViewMoment = _k[1];
    // 当前选中日期
    var _l = tslib_1.__read(react_1.useState(value), 2), curValue = _l[0], setCurValue = _l[1];
    // 选择器是否展开
    var _m = tslib_1.__read(use_default_1.useDefault(open, defaultOpen, onOpenChange), 2), active = _m[0], setActive = _m[1];
    // 输入框显示值
    var inputRef = react_1.useRef(null);
    var getInputValue = react_1.useCallback(function (value) {
        return moment_1.isMoment(value) ? value.locale(t.locale).format(format) : "";
    }, [t.locale, format]);
    var _o = tslib_1.__read(react_1.useState(getInputValue(curValue)), 2), inputValue = _o[0], setInputValue = _o[1];
    react_1.useEffect(function () {
        setCurValue(value);
        setInputValue(getInputValue(value));
    }, [format, value, getInputValue]);
    function handleChange(value, context) {
        setCurValue(value);
        setInputValue(getInputValue(value));
        onChange(value, context);
        handleClose();
    }
    function handleOpen() {
        if (disabled) {
            return;
        }
        setActive(true);
        setType("month");
    }
    function handleClose() {
        setInputValue(getInputValue(value));
        setActive(false);
    }
    return (react_1.default.createElement(Popover_1.Popover, { trigger: [
            util_1.DatePickerTrigger,
            { onOpen: handleOpen, onClose: handleClose },
        ], visible: active, onVisibleChange: setActive, placement: placement, placementOffset: placementOffset, closeOnScroll: closeOnScroll, overlay: react_1.default.createElement(dropdown_1.DropdownBox, null,
            react_1.default.createElement(CalendarPart_1.default.Panel, null,
                !!header && react_1.default.createElement(CalendarPart_1.default.Header, null, header),
                react_1.default.createElement(CalendarTable_1.CalendarTable, tslib_1.__assign({}, props, { monthOnly: true, value: curValue, onChange: handleChange, type: type, onTypeChange: setType, curViewMoment: curViewMoment, onCurViewMomentChange: setCurViewMoment })))) },
        react_1.default.createElement("div", { className: classnames_1.default("tea-monthpicker", className), style: style },
            react_1.default.createElement("div", { className: "tea-monthpicker__input" },
                react_1.default.createElement(Input_1.Input, { ref: inputRef, disabled: disabled, placeholder: placeholder, value: inputValue, onFocus: function () { return inputRef.current.blur(); } })))));
}, {
    defaultLabelAlign: "middle",
});
//# sourceMappingURL=MonthPicker.js.map