"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var react_dom_1 = tslib_1.__importDefault(require("react-dom"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var create_rocket_1 = require("../_util/create-rocket");
var justify_1 = require("../justify");
var button_1 = require("../button");
var transition_1 = require("../transition");
var use_outside_click_1 = require("../_util/use-outside-click");
function Drawer(_a) {
    var className = _a.className, style = _a.style, children = _a.children, visible = _a.visible, _b = _a.onClose, onClose = _b === void 0 ? function () { return null; } : _b, size = _a.size, placement = _a.placement, footer = _a.footer, title = _a.title, subTitle = _a.subTitle, _c = _a.subtitle, subtitle = _c === void 0 ? subTitle : _c, extra = _a.extra, disableCloseIcon = _a.disableCloseIcon, disableAnimation = _a.disableAnimation, _d = _a.outerClickClosable, outerClickClosable = _d === void 0 ? true : _d;
    var ref = react_1.useRef(null);
    var listen = use_outside_click_1.useOutsideClick(ref).listen;
    var portalInterceptProps = listen(function () { return outerClickClosable && onClose(); }).portalInterceptProps;
    var width = size === "l" ? 800 : 320;
    var from = placement === "left" ? 0 - width : width;
    var showHeader = title || subtitle || extra || !disableCloseIcon;
    return react_dom_1.default.createPortal(react_1.default.createElement(transition_1.SlideTransition, { in: visible, from: [from, 0], timeout: disableAnimation ? 0 : undefined },
        react_1.default.createElement("div", tslib_1.__assign({ ref: ref, style: style, className: classnames_1.default("tea-drawer", className, {
                "tea-drawer--left": placement === "left",
                "size-l": size === "l",
            }) }, portalInterceptProps),
            showHeader && (react_1.default.createElement("div", { className: "tea-drawer__header" },
                react_1.default.createElement(justify_1.Justify, { left: react_1.default.createElement(DrawerTitle, { title: title, subtitle: subtitle }), right: react_1.default.createElement(react_1.default.Fragment, null,
                        extra,
                        !disableCloseIcon && (react_1.default.createElement(button_1.Button, { icon: "close", onClick: onClose }))) }))),
            react_1.default.createElement(DrawerBody, null, children),
            footer && react_1.default.createElement(DrawerFooter, null, footer))), document.body);
}
exports.Drawer = Drawer;
function DrawerTitle(_a) {
    var title = _a.title, subtitle = _a.subtitle;
    var sub = typeof subtitle === "string" ? (react_1.default.createElement("span", { className: "tea-card__subtitle" }, subtitle)) : (subtitle);
    if (typeof title === "string") {
        return (react_1.default.createElement("h3", { className: "tea-h3" },
            title,
            sub));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        title,
        sub));
}
var DrawerBody = create_rocket_1.createRocket("DrawerBody", "div.tea-drawer__body", "div.tea-drawer__body-inner");
var DrawerFooter = create_rocket_1.createRocket("DrawerFooter", "div.tea-drawer__footer");
//# sourceMappingURL=Drawer.js.map