"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var tooltip_1 = require("../tooltip");
exports.Icon = react_1.forwardRef(function (props, ref) {
    var type = props.type, size = props.size, className = props.className, tooltip = props.tooltip, link = props.link, htmlProps = tslib_1.__rest(props, ["type", "size", "className", "tooltip", "link"]);
    var iconClassName = classnames_1.default("tea-icon", "tea-icon-" + type, size === "l" ? "size-l" : null, className);
    var Parent = link ? "a" : "i";
    var icon = (react_1.default.createElement(Parent, tslib_1.__assign({ ref: ref, className: iconClassName }, htmlProps)));
    if (tooltip) {
        return react_1.default.createElement(tooltip_1.Tooltip, { title: tooltip }, icon);
    }
    return icon;
});
//# sourceMappingURL=Icon.js.map