"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var create_rocket_1 = require("../_util/create-rocket");
function MetricsBoard(_a) {
    var title = _a.title, value = _a.value, unit = _a.unit, _b = _a.infos, infos = _b === void 0 ? [] : _b, onClick = _a.onClick;
    var hasOnClick = typeof onClick === "function";
    return (react_1.default.createElement("div", { className: classnames_1.default("tea-metrics-board", {
            "tea-metrics-board--link": hasOnClick,
        }), onClick: hasOnClick ? onClick : function () { return null; } },
        react_1.default.createElement("div", { className: "tea-metrics-board__header" },
            react_1.default.createElement("div", { className: "tea-metrics-board__header-title" }, title)),
        react_1.default.createElement("div", { className: "tea-metrics-board__body" },
            react_1.default.createElement("div", { className: "tea-metrics-board__value" },
                react_1.default.createElement("span", { className: "tea-metrics-board__number" }, value),
                react_1.default.createElement("span", { className: "tea-metrics-board__unit" },
                    " ",
                    unit)),
            react_1.default.createElement("div", { className: "tea-metrics-board__info" }, infos.map(function (info, index) { return (react_1.default.createElement("div", { className: "tea-metrics-board__info-item", key: index }, info)); })))));
}
exports.MetricsBoard = MetricsBoard;
MetricsBoard.InfoLabel = create_rocket_1.createRocket("MetricsBoardInfoLabel", "label.tea-metrics-board__info-label");
MetricsBoard.InfoKey = create_rocket_1.createRocket("MetricsBoardInfoKey", "label.tea-metrics-board__info-key");
//# sourceMappingURL=MetricsBoard.js.map