import React from "react";
import { ControlledProps } from "../form/controlled";
import { CheckChangeContext } from "../check";
/**
 * RadioGroup 组件所接收的属性
 */
export interface RadioGroupProps extends ControlledProps<string> {
    /**
     * 当前选中的 Radio 的 name
     */
    value?: string;
    /**
     * 值变更时回调
     */
    onChange?: (value: string, context: CheckChangeContext) => void;
    /**
     * 禁用组件
     * @default false
     */
    disabled?: boolean;
    /**
     * 使用水平布局（inline）还是纵向排列布局（column）
     * @default "inline"
     */
    layout?: "inline" | "column";
    /**
     * 单选按钮内容
     */
    children?: React.ReactNode;
}
export interface RadioGroupTarget {
    /** 当前选中的 Radio 的值 */
    value: string;
}
/**
 * 单选选项组，里面可以嵌套 <Radio />
 */
export declare function RadioGroup(props: RadioGroupProps): JSX.Element;
