"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var RegionFlag_1 = require("./RegionFlag");
exports.RegionOptionContext = react_1.default.createContext(null);
function RegionOption(props) {
    var context = react_1.useContext(exports.RegionOptionContext);
    if (context) {
        props = context.inject(props); // eslint-disable-line no-param-reassign
    }
    var country = props.country, children = props.children, dot = props.dot, selected = props.selected, onClick = props.onClick, _a = props.flag, flag = _a === void 0 ? country : _a;
    return (react_1.default.createElement("div", { className: classnames_1.default({
            "tea-region__item": true,
            "is-selected": selected,
        }), onClick: onClick },
        react_1.default.createElement(RegionFlag_1.RegionFlag, { flag: flag }),
        react_1.default.createElement("span", { className: "tea-region__name" },
            children,
            dot && react_1.default.createElement("i", { className: "tea-region__new" }))));
}
exports.RegionOption = RegionOption;
//# sourceMappingURL=RegionOption.js.map