"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var is_child_of_type_1 = require("../_util/is-child-of-type");
/**
 * 地域选择布局面板
 */
function RegionPanel(_a) {
    var children = _a.children;
    var allOptionElement = null;
    var otherChildElements = [];
    react_1.default.Children.forEach(children, function (child) {
        if (is_child_of_type_1.isChildOfType(child, RegionPanelHead)) {
            allOptionElement = child;
        }
        else {
            otherChildElements.push(child);
        }
    });
    return (react_1.default.createElement("div", { className: "tea-region" },
        allOptionElement,
        react_1.default.createElement("div", { className: "tea-region__list" }, otherChildElements)));
}
exports.RegionPanel = RegionPanel;
RegionPanel.Head = RegionPanelHead;
RegionPanel.Column = RegionPanelColumn;
RegionPanel.Group = RegionPanelGroup;
function RegionPanelHead(_a) {
    var children = _a.children;
    return react_1.default.createElement("div", { className: "tea-region__title" }, children);
}
function RegionPanelColumn(_a) {
    var children = _a.children;
    return react_1.default.createElement("div", { className: "tea-region__col" }, children);
}
function RegionPanelGroup(_a) {
    var name = _a.name, children = _a.children;
    return (react_1.default.createElement("div", { className: "tea-region__unit" },
        name && react_1.default.createElement("div", { className: "tea-region__type" }, name),
        children));
}
//# sourceMappingURL=RegionPanel.js.map