"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var text_1 = require("../text");
var TableBox_1 = require("./TableBox");
var use_middleware_1 = require("./util/use-middleware");
var is_callable_1 = require("../_util/is-callable");
exports.TableHead = react_1.forwardRef(function TableHead(props, ref) {
    var columns = props.columns, addons = props.addons, boxStyle = props.boxStyle;
    var renderColumn = use_middleware_1.useMiddleware(addons, "onInjectColumn")(function (record, rowKey, recordIndex, column) {
        var key = column.key, header = column.header;
        var children = header;
        // pass a render function
        if (is_callable_1.isCallable(header)) {
            children = header(column);
        }
        // forgot to pass, use a key as a reminder
        if (header === undefined) {
            children = key;
        }
        // plain values
        if (typeof header === "string" || typeof header === "number") {
            children = react_1.default.createElement(text_1.Text, { overflow: true }, header);
        }
        return {
            props: {},
            children: children,
        };
    });
    var tableHeaders = columns.map(function (column) {
        var _a = renderColumn(null, null, -1, column), props = _a.props, children = _a.children;
        return (react_1.default.createElement(text_1.Text, tslib_1.__assign({ key: column.key, parent: "th" }, props, { align: column.align }),
            react_1.default.createElement("div", null, children)));
    });
    return use_middleware_1.useMiddleware(addons, "onInjectHead")(function (props) { return (react_1.default.createElement("div", { className: "tea-table__header", ref: ref },
        react_1.default.createElement(TableBox_1.TableBox, { columns: columns, style: boxStyle },
            react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null, tableHeaders))))); })(props);
});
//# sourceMappingURL=TableHead.js.map