import React from "react";
import { TableAddon } from "../TableProps";
/**
 * `stylize` 插件用于支持表格各部分的样式及类名配置。
  ```jsx
  import { stylize } from '@tea/component/table/addons/stylize';
  function Example() {
    return <Table addons={[stylize(options)]} />;
  }
  ```
 */
export interface StylizeOption {
    /**
     * 组件容器自定义类名
     */
    className?: string;
    /**
     * 组件容器自定义样式
     */
    style?: React.CSSProperties;
    /**
     * 表头容器自定义类名
     */
    headClassName?: string;
    /**
     * 表头容器自定义样式
     */
    headStyle?: React.CSSProperties;
    /**
     * 表格 Body 容器自定义类名
     */
    bodyClassName?: string;
    /**
     * 表格 Body 容器自定义样式
     */
    bodyStyle?: React.CSSProperties;
}
export declare function stylize({ className, style, headClassName, headStyle, bodyClassName, bodyStyle, }: StylizeOption): TableAddon;
