"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var TimeSelect_1 = require("./TimeSelect");
var util_1 = require("./util");
function Combobox(_a) {
    var _value = _a.value, onChange = _a.onChange, _b = _a.format, format = _b === void 0 ? "HH:mm:ss" : _b, _c = _a.hourStep, hourStep = _c === void 0 ? 1 : _c, _d = _a.minuteStep, minuteStep = _d === void 0 ? 1 : _d, _e = _a.secondStep, secondStep = _e === void 0 ? 1 : _e, props = tslib_1.__rest(_a, ["value", "onChange", "format", "hourStep", "minuteStep", "secondStep"]);
    var value = util_1.getValidTimeValue(_value, props, format);
    var _f = util_1.genShowHourMinuteSecond(format), showHour = _f.showHour, showMinute = _f.showMinute, showSecond = _f.showSecond;
    var _g = util_1.getHourMinuteSecond(value), hour = _g.hour, minute = _g.minute, second = _g.second;
    var handleItemChange = function (type) { return function (selectValue, context) {
        var newValue = value.clone();
        switch (type) {
            case "hour":
                newValue.hour(selectValue);
                break;
            case "minute":
                newValue.minute(selectValue);
                break;
            case "second":
                newValue.second(selectValue);
                break;
        }
        onChange(util_1.getValidTimeValue(newValue, props, format), context);
    }; };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        showHour && (react_1.default.createElement(TimeSelect_1.TimeSelect, { value: hour, to: 23, step: hourStep, disabledValues: util_1.getDisabledHours(props), onChange: handleItemChange("hour") })),
        showMinute && (react_1.default.createElement(TimeSelect_1.TimeSelect, { value: minute, to: 59, step: minuteStep, disabledValues: util_1.getDisabledMinutes(hour, props), onChange: handleItemChange("minute") })),
        showSecond && (react_1.default.createElement(TimeSelect_1.TimeSelect, { value: second, to: 59, step: secondStep, disabledValues: util_1.getDisabledSeconds(hour, minute, props), onChange: handleItemChange("second") }))));
}
exports.Combobox = Combobox;
//# sourceMappingURL=TimeCombobox.js.map