import { BaseType } from "d3";

export function getLabelMaxWidth(nodes: BaseType[]) {
  let max = 0;
  for (const node of nodes) {
    if (node) {
      const { width } = (node as SVGTextElement).getBoundingClientRect();
      if (max < width) max = width;
    }
  }
  return Math.round(max);
}

export function nodeWidth(node: SVGGraphicsElement) {
  return node.getBBox().width;
}
