import React from "react";
import classNames from "classnames";
import { StyledProps } from "../_type";

export interface BlankStepsProps extends StyledProps {
  /**
   * 步骤内容
   */
  steps: React.ReactNode[];
}

export function BlankSteps({ steps = [], className, style }: BlankStepsProps) {
  return (
    <div
      className={classNames("tea-blank-page__step", className)}
      style={style}
    >
      {steps.map((step, index) => (
        <div className="item" key={index}>
          <i className="num">{index + 1}</i>
          {step}
        </div>
      ))}
    </div>
  );
}
