import React from "react";
import { Button } from "@tea/component/button";
import { Blank } from "@tea/component/blank";
import { Card } from "@tea/component/card";
import { Layout } from "@tea/component/layout";
import { ExternalLink } from "@tea/component/link";

const { Body, Content } = Layout;

function BlankExample() {
  return (
    <Layout>
      <Body>
        <Content>
          <Content.Body>
            <Card full>
              <Blank
                theme="permission"
                description="提供什么服务，达到什么目的，文字不超过两行。提供什么服务，达到什么目的，文字不超过两行"
                operation={
                  <>
                    <Button type="primary">前往访问管理</Button>
                    <Button>了解访问管理</Button>
                  </>
                }
                extra={
                  <>
                    <ExternalLink>查看接入流程</ExternalLink>
                    <ExternalLink>查看计价</ExternalLink>
                  </>
                }
              />
            </Card>
          </Content.Body>
        </Content>
      </Body>
    </Layout>
  );
}

export default function Demo() {
  return (
    <section
      style={{
        height: 540,
        border: "1px solid #ddd",
      }}
    >
      <BlankExample />
    </section>
  );
}
