import React from "react";
import moment from "moment";
import { DatePicker } from "@tea/component/datepicker";

const { RangePicker } = DatePicker;

export default () => {
  return (
    <>
      <section>
        <h3>范围选择</h3>
        <RangePicker
          defaultValue={[moment("2019-02-14"), moment("2019-04-01")]}
          onChange={value =>
            console.log(
              value[0].format("YYYY/MM/DD"),
              value[1].format("YYYY/MM/DD")
            )
          }
          onOpenChange={open => console.log(open ? "open" : "close")}
        />
      </section>
      <section>
        <h3>包含时间的范围选择</h3>
        <RangePicker
          showTime
          onChange={value => console.log(value[0].format(), value[1].format())}
        />
      </section>
      <section>
        <RangePicker
          separator="至"
          format="YYYY-MM-DD HH:mm"
          showTime={{ format: "HH:mm" }}
          onChange={value => console.log(value[0].format(), value[1].format())}
        />
      </section>
    </>
  );
};
