import React, { Fragment, useState } from "react";
import { Switch } from "@tea/component/switch";
import { Select } from "@tea/component/select";
import { Input } from "@tea/component/input";

export default function InputExample() {
  const [size, setSize] = useState(null);
  const [disabled, setDisabled] = useState(false);
  const [readonly, setReadonly] = useState(false);

  const [text, setText] = useState("");

  return (
    <Fragment>
      {/* Demo 演示区 */}
      <div>
        <Input
          size={size}
          value={text}
          onChange={value => setText(value)}
          placeholder="输入文本内容"
          disabled={disabled}
          readonly={readonly}
        />
      </div>
      <div style={{ marginTop: 10 }}>
        <Input
          multiline
          size={size}
          value={text}
          onChange={value => setText(value)}
          placeholder="输入文本内容"
          disabled={disabled}
          readonly={readonly}
        />
      </div>
      <hr />
      {/* Demo 配置区 */}
      <section>
        <Select
          style={{ width: "auto", marginRight: 10 }}
          value={size}
          onChange={value => setSize(value)}
          placeholder="尺寸"
          options={[
            { value: "xs", text: "xs - 极窄" },
            { value: "s", text: "s - 窄" },
            { value: "m", text: "m - 默认" },
            { value: "l", text: "l - 大宽度" },
            { value: "full", text: "full - 全宽" },
          ]}
        />
        <Switch value={disabled} onChange={value => setDisabled(value)}>
          禁用
        </Switch>
        <Switch value={readonly} onChange={value => setReadonly(value)}>
          只读
        </Switch>
      </section>
    </Fragment>
  );
}
