import React, { AnchorHTMLAttributes, forwardRef } from "react";
import classNames from "classnames";

export interface ExternalLinkProps
  extends AnchorHTMLAttributes<HTMLAnchorElement> {
  /**
   * 不显示为高亮色
   * @default false
   */
  weak?: boolean;
}

export const ExternalLink = forwardRef<HTMLAnchorElement, ExternalLinkProps>(
  ({ className, weak, children, ...props }, ref) => (
    <a
      target="_blank"
      {...props}
      ref={ref}
      className={classNames(
        "tea-link-external",
        {
          "tea-link-external--black": weak,
        },
        className
      )}
    >
      {children}
    </a>
  )
);
