import React from "react";
import classNames from "classnames";
import { StyledProps } from "../_type";

export interface MenuGroupProps extends StyledProps {
  /**
   * 标题
   */
  title?: React.ReactNode;

  /**
   * 菜单内容（Menu.SubMenu 或 Menu.Item）
   */
  children?: React.ReactNode;
}

export function MenuGroup({
  title,
  children,
  className,
  style,
}: MenuGroupProps) {
  return (
    <>
      <li className={classNames("tea-menu__label", className)} style={style}>
        <a className="tea-menu__item">
          <div className="tea-menu__text">{title}</div>
        </a>
      </li>
      {children}
    </>
  );
}
