import React from "react";
import { Icon } from "../icon";

export interface ModalMessageProps {
  /**
   * 要提示的消息
   */
  message: React.ReactNode;

  /**
   * 可选的详细解释
   */
  description?: React.ReactNode;

  /**
   * 提示图标
   */
  icon?: "error" | "warning" | "pending" | "infoblue" | "success";
}

export function ModalMessage({
  icon,
  message,
  description,
}: ModalMessageProps) {
  return (
    <div className="tea-media">
      {icon && (
        <div className="tea-media__left">
          <Icon type={icon} size="l" />
        </div>
      )}
      <div className="tea-media__body">
        <h3 className="tea-dialog__messagetitle">{message}</h3>
        {message && (
          <div className="tea-dialog__messagetext">{description}</div>
        )}
      </div>
    </div>
  );
}
