import React, { Fragment, useState } from "react";
import { Modal } from "@tea/component/modal";
import { Button } from "@tea/component/button";
import { DatePicker } from "@tea/component/datepicker";

export default function ModalBasicExample() {
  const [visible, setVisible] = useState(false);

  const open = () => setVisible(true);
  const close = () => setVisible(false);

  return (
    <Fragment>
      <Button type="primary" onClick={open}>
        打开
      </Button>
      <Modal
        maskClosable
        visible={visible}
        caption="对话框标题"
        onClose={close}
      >
        <Modal.Body>
          <DatePicker />
        </Modal.Body>
        <Modal.Footer />
      </Modal>
    </Fragment>
  );
}
