import React, { useState, Fragment } from "react";
import { PopConfirm } from "@tea/component/popconfirm";
import { Button } from "@tea/component/button";

export default function PopConfirmExample() {
  const [confirmVisible, setConfirmVisible] = useState(false);

  return (
    <PopConfirm
      title="确定要解除关联？"
      message="解除后，配置将不再生效，也不做关联。"
      visible={confirmVisible}
      onVisibleChange={setConfirmVisible}
      footer={
        <Fragment>
          <Button
            type="link"
            onClick={() => {
              setConfirmVisible(false);
              console.log("已解除");
            }}
          >
            解除
          </Button>
          <Button
            type="text"
            onClick={() => {
              setConfirmVisible(false);
              console.log("已取消");
            }}
          >
            取消
          </Button>
        </Fragment>
      }
      placement="top-start"
    >
      <Button type="text">解除关联</Button>
    </PopConfirm>
  );
}
