import React, { useState } from "react";
import { Select } from "@tea/component/select";
import { Form } from "@tea/component/form";
import { Button } from "@tea/component/button";

const options = [
  { value: "strawberry", text: "草莓", tooltip: "甜甜甜" },
  { value: "apple", text: "苹果", tooltip: "每日一苹果，医生远离我" },
  { value: "orange", text: "橙子", tooltip: "丰富 VC 含量" },
  { value: "durian", text: "榴莲", disabled: true, tooltip: "榴莲已售罄" },
];

export default function SelectExample() {
  const [favorite, setFavorite] = useState(null);

  return (
    <Form>
      <Form.Item label="原生下拉">
        <Select
          type="native"
          size="m"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
          placeholder="请选择你最爱的水果"
        />
      </Form.Item>
      <Form.Item label="模拟下拉">
        <Select
          type="simulate"
          appearence="default"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
          placeholder="请选择你最爱的水果"
        />
      </Form.Item>
      <Form.Item label="下拉按钮">
        <Select
          type="simulate"
          appearence="button"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
          placeholder="请选择你最爱的水果"
        />
      </Form.Item>
      <Form.Item label="下拉链接">
        <Select
          type="simulate"
          appearence="link"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
          placeholder="请选择你最爱的水果"
        />
      </Form.Item>
      <Form.Item label="筛选">
        <Select
          type="simulate"
          appearence="filter"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
          placeholder="请选择你最爱的水果"
        />
      </Form.Item>
      <Form.Item label="自定义">
        <Select
          type="simulate"
          appearence="pure"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
          button={<Button type="icon" icon="more" />}
        />
      </Form.Item>
    </Form>
  );
}
