import React, { useState } from "react";
import { Select, SelectMultiple } from "@tea/component/select";
import { Form } from "@tea/component/form";

const options = [
  { value: "strawberry", text: "草莓", tooltip: "甜甜甜" },
  { value: "apple", text: "苹果", tooltip: "每日一苹果，医生远离我" },
  { value: "orange", text: "橙子", tooltip: "丰富 VC 含量" },
  { value: "durian", text: "榴莲", disabled: true, tooltip: "榴莲已售罄" },
  { value: "coca-cola", text: "可口可乐" },
  { value: "pepsi-cola", text: "百事可乐" },
];

export default function SelectExample() {
  const [favorite, setFavorite] = useState(null);
  return (
    <Form>
      <Form.Item label="单选">
        <Select
          searchable
          boxSizeSync
          size="m"
          type="simulate"
          appearence="button"
          options={options}
          value={favorite}
          onChange={value => setFavorite(value)}
        />
      </Form.Item>
      <Form.Item label="多选">
        <SelectMultiple
          searchable
          size="m"
          appearence="button"
          options={options}
          allOption={{
            value: "all",
            text: "我都要",
            tooltip: "胖子是没有前途的",
          }}
        />
      </Form.Item>
    </Form>
  );
}
