import React from "react";
import { BasicLine, BasicLineProps } from "../basicline";
import { Omit } from "../_type";

/**
 * SimpleLine 组件支持的属性。
 */
export interface SimpleLineProps
  extends Omit<
    BasicLineProps,
    "xAxis" | "color" | "scale" | "legend" | "yAxis" | "tooltip"
  > {
  /**
   *  Y 轴
   * @default false
   */
  yAxis?: boolean | BasicLineProps["yAxis"];

  /**
   * 提示框
   * @default false
   */
  tooltip?: BasicLineProps["tooltip"];
}

export function SimpleLine(props: SimpleLineProps) {
  const {
    height,
    width,
    dataSource,
    position,
    size = 3,
    tooltip = false,
    yAxis = false,
    tips,
  } = props;

  return (
    <BasicLine
      xAxis={false}
      legend={false}
      height={height}
      width={width}
      dataSource={dataSource}
      position={position}
      size={size}
      tooltip={tooltip}
      yAxis={yAxis}
      tips={tips}
    />
  );
}
