import React from "react";
import { TableColumn } from "./TableProps";
import { TableColGroup } from "./TableColGroup";
import { StyledProps } from "../_type";

export interface TableBoxProps extends StyledProps {
  columns: TableColumn[];
  children: React.ReactChild;
}

export function TableBox({ columns, children, style }: TableBoxProps) {
  return (
    <table className="tea-table__box" style={style}>
      <TableColGroup columns={columns} />
      {children}
    </table>
  );
}
