import React from "react";
import classNames from "classnames";
import { useTranslation } from "../i18n";
import { StyledProps } from "../_type";

export interface EmptyTipProps extends StyledProps {
  /**
   * 空数据提示文案
   * @default "暂无数据"
   */
  emptyText?: React.ReactNode;
}

export function EmptyTip(props: EmptyTipProps) {
  const t = useTranslation();
  const { emptyText = t.emptyText, className, style } = props;
  return (
    <span className={classNames("tea-action-state", className)} style={style}>
      {typeof emptyText === "string" ? (
        <span className="tea-action-state__text">{emptyText}</span>
      ) : (
        emptyText
      )}
    </span>
  );
}
