/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	auth "tkestack.io/tke/api/auth"
)

// FakeAPIKeys implements APIKeyInterface
type FakeAPIKeys struct {
	Fake *FakeAuth
}

var apikeysResource = schema.GroupVersionResource{Group: "auth.tkestack.io", Version: "", Resource: "apikeys"}

var apikeysKind = schema.GroupVersionKind{Group: "auth.tkestack.io", Version: "", Kind: "APIKey"}

// Get takes name of the aPIKey, and returns the corresponding aPIKey object, and an error if there is any.
func (c *FakeAPIKeys) Get(name string, options v1.GetOptions) (result *auth.APIKey, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(apikeysResource, name), &auth.APIKey{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.APIKey), err
}

// List takes label and field selectors, and returns the list of APIKeys that match those selectors.
func (c *FakeAPIKeys) List(opts v1.ListOptions) (result *auth.APIKeyList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(apikeysResource, apikeysKind, opts), &auth.APIKeyList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &auth.APIKeyList{ListMeta: obj.(*auth.APIKeyList).ListMeta}
	for _, item := range obj.(*auth.APIKeyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aPIKeys.
func (c *FakeAPIKeys) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(apikeysResource, opts))
}

// Create takes the representation of a aPIKey and creates it.  Returns the server's representation of the aPIKey, and an error, if there is any.
func (c *FakeAPIKeys) Create(aPIKey *auth.APIKey) (result *auth.APIKey, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(apikeysResource, aPIKey), &auth.APIKey{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.APIKey), err
}

// Update takes the representation of a aPIKey and updates it. Returns the server's representation of the aPIKey, and an error, if there is any.
func (c *FakeAPIKeys) Update(aPIKey *auth.APIKey) (result *auth.APIKey, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(apikeysResource, aPIKey), &auth.APIKey{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.APIKey), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeAPIKeys) UpdateStatus(aPIKey *auth.APIKey) (*auth.APIKey, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(apikeysResource, "status", aPIKey), &auth.APIKey{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.APIKey), err
}

// Delete takes name of the aPIKey and deletes it. Returns an error if one occurs.
func (c *FakeAPIKeys) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(apikeysResource, name), &auth.APIKey{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAPIKeys) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(apikeysResource, listOptions)

	_, err := c.Fake.Invokes(action, &auth.APIKeyList{})
	return err
}

// Patch applies the patch and returns the patched aPIKey.
func (c *FakeAPIKeys) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *auth.APIKey, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(apikeysResource, name, pt, data, subresources...), &auth.APIKey{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.APIKey), err
}
