/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	auth "tkestack.io/tke/api/auth"
)

// FakeLocalGroups implements LocalGroupInterface
type FakeLocalGroups struct {
	Fake *FakeAuth
}

var localgroupsResource = schema.GroupVersionResource{Group: "auth.tkestack.io", Version: "", Resource: "localgroups"}

var localgroupsKind = schema.GroupVersionKind{Group: "auth.tkestack.io", Version: "", Kind: "LocalGroup"}

// Get takes name of the localGroup, and returns the corresponding localGroup object, and an error if there is any.
func (c *FakeLocalGroups) Get(name string, options v1.GetOptions) (result *auth.LocalGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(localgroupsResource, name), &auth.LocalGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalGroup), err
}

// List takes label and field selectors, and returns the list of LocalGroups that match those selectors.
func (c *FakeLocalGroups) List(opts v1.ListOptions) (result *auth.LocalGroupList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(localgroupsResource, localgroupsKind, opts), &auth.LocalGroupList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &auth.LocalGroupList{ListMeta: obj.(*auth.LocalGroupList).ListMeta}
	for _, item := range obj.(*auth.LocalGroupList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested localGroups.
func (c *FakeLocalGroups) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(localgroupsResource, opts))
}

// Create takes the representation of a localGroup and creates it.  Returns the server's representation of the localGroup, and an error, if there is any.
func (c *FakeLocalGroups) Create(localGroup *auth.LocalGroup) (result *auth.LocalGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(localgroupsResource, localGroup), &auth.LocalGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalGroup), err
}

// Update takes the representation of a localGroup and updates it. Returns the server's representation of the localGroup, and an error, if there is any.
func (c *FakeLocalGroups) Update(localGroup *auth.LocalGroup) (result *auth.LocalGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(localgroupsResource, localGroup), &auth.LocalGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalGroup), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeLocalGroups) UpdateStatus(localGroup *auth.LocalGroup) (*auth.LocalGroup, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(localgroupsResource, "status", localGroup), &auth.LocalGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalGroup), err
}

// Delete takes name of the localGroup and deletes it. Returns an error if one occurs.
func (c *FakeLocalGroups) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(localgroupsResource, name), &auth.LocalGroup{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLocalGroups) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(localgroupsResource, listOptions)

	_, err := c.Fake.Invokes(action, &auth.LocalGroupList{})
	return err
}

// Patch applies the patch and returns the patched localGroup.
func (c *FakeLocalGroups) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *auth.LocalGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(localgroupsResource, name, pt, data, subresources...), &auth.LocalGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.LocalGroup), err
}
