/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	auth "tkestack.io/tke/api/auth"
)

// FakePolicies implements PolicyInterface
type FakePolicies struct {
	Fake *FakeAuth
}

var policiesResource = schema.GroupVersionResource{Group: "auth.tkestack.io", Version: "", Resource: "policies"}

var policiesKind = schema.GroupVersionKind{Group: "auth.tkestack.io", Version: "", Kind: "Policy"}

// Get takes name of the policy, and returns the corresponding policy object, and an error if there is any.
func (c *FakePolicies) Get(name string, options v1.GetOptions) (result *auth.Policy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(policiesResource, name), &auth.Policy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.Policy), err
}

// List takes label and field selectors, and returns the list of Policies that match those selectors.
func (c *FakePolicies) List(opts v1.ListOptions) (result *auth.PolicyList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(policiesResource, policiesKind, opts), &auth.PolicyList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &auth.PolicyList{ListMeta: obj.(*auth.PolicyList).ListMeta}
	for _, item := range obj.(*auth.PolicyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested policies.
func (c *FakePolicies) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(policiesResource, opts))
}

// Create takes the representation of a policy and creates it.  Returns the server's representation of the policy, and an error, if there is any.
func (c *FakePolicies) Create(policy *auth.Policy) (result *auth.Policy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(policiesResource, policy), &auth.Policy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.Policy), err
}

// Update takes the representation of a policy and updates it. Returns the server's representation of the policy, and an error, if there is any.
func (c *FakePolicies) Update(policy *auth.Policy) (result *auth.Policy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(policiesResource, policy), &auth.Policy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.Policy), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakePolicies) UpdateStatus(policy *auth.Policy) (*auth.Policy, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(policiesResource, "status", policy), &auth.Policy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.Policy), err
}

// Delete takes name of the policy and deletes it. Returns an error if one occurs.
func (c *FakePolicies) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(policiesResource, name), &auth.Policy{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePolicies) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(policiesResource, listOptions)

	_, err := c.Fake.Invokes(action, &auth.PolicyList{})
	return err
}

// Patch applies the patch and returns the patched policy.
func (c *FakePolicies) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *auth.Policy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(policiesResource, name, pt, data, subresources...), &auth.Policy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*auth.Policy), err
}
