/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package internalversion

import (
	rest "k8s.io/client-go/rest"
	monitor "tkestack.io/tke/api/monitor"
)

// MetricsGetter has a method to return a MetricInterface.
// A group's client should implement this interface.
type MetricsGetter interface {
	Metrics() MetricInterface
}

// MetricInterface has methods to work with Metric resources.
type MetricInterface interface {
	Create(*monitor.Metric) (*monitor.Metric, error)
	MetricExpansion
}

// metrics implements MetricInterface
type metrics struct {
	client rest.Interface
}

// newMetrics returns a Metrics
func newMetrics(c *MonitorClient) *metrics {
	return &metrics{
		client: c.RESTClient(),
	}
}

// Create takes the representation of a metric and creates it.  Returns the server's representation of the metric, and an error, if there is any.
func (c *metrics) Create(metric *monitor.Metric) (result *monitor.Metric, err error) {
	result = &monitor.Metric{}
	err = c.client.Post().
		Resource("metrics").
		Body(metric).
		Do().
		Into(result)
	return
}
