/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	notify "tkestack.io/tke/api/notify"
)

// FakeReceivers implements ReceiverInterface
type FakeReceivers struct {
	Fake *FakeNotify
}

var receiversResource = schema.GroupVersionResource{Group: "notify.tkestack.io", Version: "", Resource: "receivers"}

var receiversKind = schema.GroupVersionKind{Group: "notify.tkestack.io", Version: "", Kind: "Receiver"}

// Get takes name of the receiver, and returns the corresponding receiver object, and an error if there is any.
func (c *FakeReceivers) Get(name string, options v1.GetOptions) (result *notify.Receiver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(receiversResource, name), &notify.Receiver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notify.Receiver), err
}

// List takes label and field selectors, and returns the list of Receivers that match those selectors.
func (c *FakeReceivers) List(opts v1.ListOptions) (result *notify.ReceiverList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(receiversResource, receiversKind, opts), &notify.ReceiverList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &notify.ReceiverList{ListMeta: obj.(*notify.ReceiverList).ListMeta}
	for _, item := range obj.(*notify.ReceiverList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested receivers.
func (c *FakeReceivers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(receiversResource, opts))
}

// Create takes the representation of a receiver and creates it.  Returns the server's representation of the receiver, and an error, if there is any.
func (c *FakeReceivers) Create(receiver *notify.Receiver) (result *notify.Receiver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(receiversResource, receiver), &notify.Receiver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notify.Receiver), err
}

// Update takes the representation of a receiver and updates it. Returns the server's representation of the receiver, and an error, if there is any.
func (c *FakeReceivers) Update(receiver *notify.Receiver) (result *notify.Receiver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(receiversResource, receiver), &notify.Receiver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notify.Receiver), err
}

// Delete takes name of the receiver and deletes it. Returns an error if one occurs.
func (c *FakeReceivers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(receiversResource, name), &notify.Receiver{})
	return err
}

// Patch applies the patch and returns the patched receiver.
func (c *FakeReceivers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *notify.Receiver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(receiversResource, name, pt, data, subresources...), &notify.Receiver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notify.Receiver), err
}
