/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package internalversion

import (
	rest "k8s.io/client-go/rest"
	"tkestack.io/tke/api/client/clientset/internalversion/scheme"
)

type PlatformInterface interface {
	RESTClient() rest.Interface
	CSIOperatorsGetter
	ClustersGetter
	ClusterAddonsGetter
	ClusterAddonTypesGetter
	ClusterCredentialsGetter
	ConfigMapsGetter
	CronHPAsGetter
	GPUManagersGetter
	HelmsGetter
	IPAMsGetter
	LBCFsGetter
	LogCollectorsGetter
	MachinesGetter
	PersistentEventsGetter
	PrometheusesGetter
	RegistriesGetter
	TappControllersGetter
	VolumeDecoratorsGetter
}

// PlatformClient is used to interact with features provided by the platform.tkestack.io group.
type PlatformClient struct {
	restClient rest.Interface
}

func (c *PlatformClient) CSIOperators() CSIOperatorInterface {
	return newCSIOperators(c)
}

func (c *PlatformClient) Clusters() ClusterInterface {
	return newClusters(c)
}

func (c *PlatformClient) ClusterAddons() ClusterAddonInterface {
	return newClusterAddons(c)
}

func (c *PlatformClient) ClusterAddonTypes() ClusterAddonTypeInterface {
	return newClusterAddonTypes(c)
}

func (c *PlatformClient) ClusterCredentials() ClusterCredentialInterface {
	return newClusterCredentials(c)
}

func (c *PlatformClient) ConfigMaps() ConfigMapInterface {
	return newConfigMaps(c)
}

func (c *PlatformClient) CronHPAs() CronHPAInterface {
	return newCronHPAs(c)
}

func (c *PlatformClient) GPUManagers() GPUManagerInterface {
	return newGPUManagers(c)
}

func (c *PlatformClient) Helms() HelmInterface {
	return newHelms(c)
}

func (c *PlatformClient) IPAMs() IPAMInterface {
	return newIPAMs(c)
}

func (c *PlatformClient) LBCFs() LBCFInterface {
	return newLBCFs(c)
}

func (c *PlatformClient) LogCollectors() LogCollectorInterface {
	return newLogCollectors(c)
}

func (c *PlatformClient) Machines() MachineInterface {
	return newMachines(c)
}

func (c *PlatformClient) PersistentEvents() PersistentEventInterface {
	return newPersistentEvents(c)
}

func (c *PlatformClient) Prometheuses() PrometheusInterface {
	return newPrometheuses(c)
}

func (c *PlatformClient) Registries() RegistryInterface {
	return newRegistries(c)
}

func (c *PlatformClient) TappControllers() TappControllerInterface {
	return newTappControllers(c)
}

func (c *PlatformClient) VolumeDecorators() VolumeDecoratorInterface {
	return newVolumeDecorators(c)
}

// NewForConfig creates a new PlatformClient for the given config.
func NewForConfig(c *rest.Config) (*PlatformClient, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &PlatformClient{client}, nil
}

// NewForConfigOrDie creates a new PlatformClient for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *PlatformClient {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new PlatformClient for the given RESTClient.
func New(c rest.Interface) *PlatformClient {
	return &PlatformClient{c}
}

func setConfigDefaults(config *rest.Config) error {
	config.APIPath = "/apis"
	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}
	if config.GroupVersion == nil || config.GroupVersion.Group != scheme.Scheme.PrioritizedVersionsForGroup("platform.tkestack.io")[0].Group {
		gv := scheme.Scheme.PrioritizedVersionsForGroup("platform.tkestack.io")[0]
		config.GroupVersion = &gv
	}
	config.NegotiatedSerializer = scheme.Codecs

	if config.QPS == 0 {
		config.QPS = 5
	}
	if config.Burst == 0 {
		config.Burst = 10
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *PlatformClient) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
