/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	registry "tkestack.io/tke/api/registry"
)

// FakeChartGroups implements ChartGroupInterface
type FakeChartGroups struct {
	Fake *FakeRegistry
}

var chartgroupsResource = schema.GroupVersionResource{Group: "registry.tkestack.io", Version: "", Resource: "chartgroups"}

var chartgroupsKind = schema.GroupVersionKind{Group: "registry.tkestack.io", Version: "", Kind: "ChartGroup"}

// Get takes name of the chartGroup, and returns the corresponding chartGroup object, and an error if there is any.
func (c *FakeChartGroups) Get(name string, options v1.GetOptions) (result *registry.ChartGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(chartgroupsResource, name), &registry.ChartGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*registry.ChartGroup), err
}

// List takes label and field selectors, and returns the list of ChartGroups that match those selectors.
func (c *FakeChartGroups) List(opts v1.ListOptions) (result *registry.ChartGroupList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(chartgroupsResource, chartgroupsKind, opts), &registry.ChartGroupList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &registry.ChartGroupList{ListMeta: obj.(*registry.ChartGroupList).ListMeta}
	for _, item := range obj.(*registry.ChartGroupList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested chartGroups.
func (c *FakeChartGroups) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(chartgroupsResource, opts))
}

// Create takes the representation of a chartGroup and creates it.  Returns the server's representation of the chartGroup, and an error, if there is any.
func (c *FakeChartGroups) Create(chartGroup *registry.ChartGroup) (result *registry.ChartGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(chartgroupsResource, chartGroup), &registry.ChartGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*registry.ChartGroup), err
}

// Update takes the representation of a chartGroup and updates it. Returns the server's representation of the chartGroup, and an error, if there is any.
func (c *FakeChartGroups) Update(chartGroup *registry.ChartGroup) (result *registry.ChartGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(chartgroupsResource, chartGroup), &registry.ChartGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*registry.ChartGroup), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeChartGroups) UpdateStatus(chartGroup *registry.ChartGroup) (*registry.ChartGroup, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(chartgroupsResource, "status", chartGroup), &registry.ChartGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*registry.ChartGroup), err
}

// Delete takes name of the chartGroup and deletes it. Returns an error if one occurs.
func (c *FakeChartGroups) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(chartgroupsResource, name), &registry.ChartGroup{})
	return err
}

// Patch applies the patch and returns the patched chartGroup.
func (c *FakeChartGroups) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *registry.ChartGroup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(chartgroupsResource, name, pt, data, subresources...), &registry.ChartGroup{})
	if obj == nil {
		return nil, err
	}
	return obj.(*registry.ChartGroup), err
}
