/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	authv1 "tkestack.io/tke/api/auth/v1"
)

// FakeRoles implements RoleInterface
type FakeRoles struct {
	Fake *FakeAuthV1
}

var rolesResource = schema.GroupVersionResource{Group: "auth.tkestack.io", Version: "v1", Resource: "roles"}

var rolesKind = schema.GroupVersionKind{Group: "auth.tkestack.io", Version: "v1", Kind: "Role"}

// Get takes name of the role, and returns the corresponding role object, and an error if there is any.
func (c *FakeRoles) Get(name string, options v1.GetOptions) (result *authv1.Role, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(rolesResource, name), &authv1.Role{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Role), err
}

// List takes label and field selectors, and returns the list of Roles that match those selectors.
func (c *FakeRoles) List(opts v1.ListOptions) (result *authv1.RoleList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(rolesResource, rolesKind, opts), &authv1.RoleList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &authv1.RoleList{ListMeta: obj.(*authv1.RoleList).ListMeta}
	for _, item := range obj.(*authv1.RoleList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested roles.
func (c *FakeRoles) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(rolesResource, opts))
}

// Create takes the representation of a role and creates it.  Returns the server's representation of the role, and an error, if there is any.
func (c *FakeRoles) Create(role *authv1.Role) (result *authv1.Role, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(rolesResource, role), &authv1.Role{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Role), err
}

// Update takes the representation of a role and updates it. Returns the server's representation of the role, and an error, if there is any.
func (c *FakeRoles) Update(role *authv1.Role) (result *authv1.Role, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(rolesResource, role), &authv1.Role{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Role), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeRoles) UpdateStatus(role *authv1.Role) (*authv1.Role, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(rolesResource, "status", role), &authv1.Role{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Role), err
}

// Delete takes name of the role and deletes it. Returns an error if one occurs.
func (c *FakeRoles) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(rolesResource, name), &authv1.Role{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRoles) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(rolesResource, listOptions)

	_, err := c.Fake.Invokes(action, &authv1.RoleList{})
	return err
}

// Patch applies the patch and returns the patched role.
func (c *FakeRoles) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *authv1.Role, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(rolesResource, name, pt, data, subresources...), &authv1.Role{})
	if obj == nil {
		return nil, err
	}
	return obj.(*authv1.Role), err
}
