/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	notifyv1 "tkestack.io/tke/api/notify/v1"
)

// FakeChannels implements ChannelInterface
type FakeChannels struct {
	Fake *FakeNotifyV1
}

var channelsResource = schema.GroupVersionResource{Group: "notify.tkestack.io", Version: "v1", Resource: "channels"}

var channelsKind = schema.GroupVersionKind{Group: "notify.tkestack.io", Version: "v1", Kind: "Channel"}

// Get takes name of the channel, and returns the corresponding channel object, and an error if there is any.
func (c *FakeChannels) Get(name string, options v1.GetOptions) (result *notifyv1.Channel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(channelsResource, name), &notifyv1.Channel{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Channel), err
}

// List takes label and field selectors, and returns the list of Channels that match those selectors.
func (c *FakeChannels) List(opts v1.ListOptions) (result *notifyv1.ChannelList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(channelsResource, channelsKind, opts), &notifyv1.ChannelList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &notifyv1.ChannelList{ListMeta: obj.(*notifyv1.ChannelList).ListMeta}
	for _, item := range obj.(*notifyv1.ChannelList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested channels.
func (c *FakeChannels) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(channelsResource, opts))
}

// Create takes the representation of a channel and creates it.  Returns the server's representation of the channel, and an error, if there is any.
func (c *FakeChannels) Create(channel *notifyv1.Channel) (result *notifyv1.Channel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(channelsResource, channel), &notifyv1.Channel{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Channel), err
}

// Update takes the representation of a channel and updates it. Returns the server's representation of the channel, and an error, if there is any.
func (c *FakeChannels) Update(channel *notifyv1.Channel) (result *notifyv1.Channel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(channelsResource, channel), &notifyv1.Channel{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Channel), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeChannels) UpdateStatus(channel *notifyv1.Channel) (*notifyv1.Channel, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(channelsResource, "status", channel), &notifyv1.Channel{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Channel), err
}

// Delete takes name of the channel and deletes it. Returns an error if one occurs.
func (c *FakeChannels) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(channelsResource, name), &notifyv1.Channel{})
	return err
}

// Patch applies the patch and returns the patched channel.
func (c *FakeChannels) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *notifyv1.Channel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(channelsResource, name, pt, data, subresources...), &notifyv1.Channel{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Channel), err
}
