/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	notifyv1 "tkestack.io/tke/api/notify/v1"
)

// FakeMessages implements MessageInterface
type FakeMessages struct {
	Fake *FakeNotifyV1
}

var messagesResource = schema.GroupVersionResource{Group: "notify.tkestack.io", Version: "v1", Resource: "messages"}

var messagesKind = schema.GroupVersionKind{Group: "notify.tkestack.io", Version: "v1", Kind: "Message"}

// Get takes name of the message, and returns the corresponding message object, and an error if there is any.
func (c *FakeMessages) Get(name string, options v1.GetOptions) (result *notifyv1.Message, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(messagesResource, name), &notifyv1.Message{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Message), err
}

// List takes label and field selectors, and returns the list of Messages that match those selectors.
func (c *FakeMessages) List(opts v1.ListOptions) (result *notifyv1.MessageList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(messagesResource, messagesKind, opts), &notifyv1.MessageList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &notifyv1.MessageList{ListMeta: obj.(*notifyv1.MessageList).ListMeta}
	for _, item := range obj.(*notifyv1.MessageList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested messages.
func (c *FakeMessages) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(messagesResource, opts))
}

// Create takes the representation of a message and creates it.  Returns the server's representation of the message, and an error, if there is any.
func (c *FakeMessages) Create(message *notifyv1.Message) (result *notifyv1.Message, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(messagesResource, message), &notifyv1.Message{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Message), err
}

// Update takes the representation of a message and updates it. Returns the server's representation of the message, and an error, if there is any.
func (c *FakeMessages) Update(message *notifyv1.Message) (result *notifyv1.Message, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(messagesResource, message), &notifyv1.Message{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Message), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeMessages) UpdateStatus(message *notifyv1.Message) (*notifyv1.Message, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(messagesResource, "status", message), &notifyv1.Message{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Message), err
}

// Delete takes name of the message and deletes it. Returns an error if one occurs.
func (c *FakeMessages) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(messagesResource, name), &notifyv1.Message{})
	return err
}

// Patch applies the patch and returns the patched message.
func (c *FakeMessages) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *notifyv1.Message, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(messagesResource, name, pt, data, subresources...), &notifyv1.Message{})
	if obj == nil {
		return nil, err
	}
	return obj.(*notifyv1.Message), err
}
