/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	registryv1 "tkestack.io/tke/api/registry/v1"
)

// FakeRepositories implements RepositoryInterface
type FakeRepositories struct {
	Fake *FakeRegistryV1
	ns   string
}

var repositoriesResource = schema.GroupVersionResource{Group: "registry.tkestack.io", Version: "v1", Resource: "repositories"}

var repositoriesKind = schema.GroupVersionKind{Group: "registry.tkestack.io", Version: "v1", Kind: "Repository"}

// Get takes name of the repository, and returns the corresponding repository object, and an error if there is any.
func (c *FakeRepositories) Get(name string, options v1.GetOptions) (result *registryv1.Repository, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(repositoriesResource, c.ns, name), &registryv1.Repository{})

	if obj == nil {
		return nil, err
	}
	return obj.(*registryv1.Repository), err
}

// List takes label and field selectors, and returns the list of Repositories that match those selectors.
func (c *FakeRepositories) List(opts v1.ListOptions) (result *registryv1.RepositoryList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(repositoriesResource, repositoriesKind, c.ns, opts), &registryv1.RepositoryList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &registryv1.RepositoryList{ListMeta: obj.(*registryv1.RepositoryList).ListMeta}
	for _, item := range obj.(*registryv1.RepositoryList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested repositories.
func (c *FakeRepositories) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(repositoriesResource, c.ns, opts))

}

// Create takes the representation of a repository and creates it.  Returns the server's representation of the repository, and an error, if there is any.
func (c *FakeRepositories) Create(repository *registryv1.Repository) (result *registryv1.Repository, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(repositoriesResource, c.ns, repository), &registryv1.Repository{})

	if obj == nil {
		return nil, err
	}
	return obj.(*registryv1.Repository), err
}

// Update takes the representation of a repository and updates it. Returns the server's representation of the repository, and an error, if there is any.
func (c *FakeRepositories) Update(repository *registryv1.Repository) (result *registryv1.Repository, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(repositoriesResource, c.ns, repository), &registryv1.Repository{})

	if obj == nil {
		return nil, err
	}
	return obj.(*registryv1.Repository), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeRepositories) UpdateStatus(repository *registryv1.Repository) (*registryv1.Repository, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(repositoriesResource, "status", c.ns, repository), &registryv1.Repository{})

	if obj == nil {
		return nil, err
	}
	return obj.(*registryv1.Repository), err
}

// Delete takes name of the repository and deletes it. Returns an error if one occurs.
func (c *FakeRepositories) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(repositoriesResource, c.ns, name), &registryv1.Repository{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRepositories) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(repositoriesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &registryv1.RepositoryList{})
	return err
}

// Patch applies the patch and returns the patched repository.
func (c *FakeRepositories) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *registryv1.Repository, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(repositoriesResource, c.ns, name, pt, data, subresources...), &registryv1.Repository{})

	if obj == nil {
		return nil, err
	}
	return obj.(*registryv1.Repository), err
}
