/*
 * Tencent is pleased to support the open source community by making TKEStack
 * available.
 *
 * Copyright (C) 2012-2019 Tencent. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 * https://opensource.org/licenses/Apache-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 */

// Code generated by lister-gen. DO NOT EDIT.

package internalversion

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	registry "tkestack.io/tke/api/registry"
)

// ChartGroupLister helps list ChartGroups.
type ChartGroupLister interface {
	// List lists all ChartGroups in the indexer.
	List(selector labels.Selector) (ret []*registry.ChartGroup, err error)
	// Get retrieves the ChartGroup from the index for a given name.
	Get(name string) (*registry.ChartGroup, error)
	ChartGroupListerExpansion
}

// chartGroupLister implements the ChartGroupLister interface.
type chartGroupLister struct {
	indexer cache.Indexer
}

// NewChartGroupLister returns a new ChartGroupLister.
func NewChartGroupLister(indexer cache.Indexer) ChartGroupLister {
	return &chartGroupLister{indexer: indexer}
}

// List lists all ChartGroups in the indexer.
func (s *chartGroupLister) List(selector labels.Selector) (ret []*registry.ChartGroup, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*registry.ChartGroup))
	})
	return ret, err
}

// Get retrieves the ChartGroup from the index for a given name.
func (s *chartGroupLister) Get(name string) (*registry.ChartGroup, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(registry.Resource("chartgroup"), name)
	}
	return obj.(*registry.ChartGroup), nil
}
